#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: control.pl,v 1.0.0.1 Wed 02 Apr 2008 09:24:53 PM CEST mstauber Exp $
# Copyright 2006-2008 Solarspeed Ltd. All rights reserved.
#
# Handler which stops, starts and reboots VPS's.
#

use CCE;
use POSIX qw(isalpha);

$DEBUG = 0;

my $cce = new CCE('Domain' => 'vz-vserver');

if ($DEBUG == 0) {
    $cce->connectfd();
}
else {
    $cce->connectuds(); # only for debugging
}

if ($DEBUG == 0) {
    ($sys_oidmasternode) = $cce->find('VserverMasterNode');
    ($ok, $VserverMasterNode) = $cce->get($sys_oidmasternode);
    $vpsid = $VserverMasterNode->{gui_list_ip};
    #system("echo \"VPSID: $vpsid\" > /tmp/vpsctl");

    ($sys_oidvpsstatus) = $cce->find('Vserver', {'vpsid' => $vpsid});
    ($ok, $vps) = $cce->get($sys_oidvpsstatus);
    $vpsstatus = $vps->{status};
    #system("echo \"VPSID: $vpsid - status: $vpsstatus \" >> /tmp/vpsctl");
}
else {
    $vpsid = 3; # In debug mode only!
    #system("echo \"VPSID-debug: $vpsid\" > /tmp/vpsctl");
}

$vserver = $cce->event_object();
$vserver_new = $cce->event_new();
$vserver_old = $cce->event_old();

($sys_oid) = $cce->find('VserverMasterNode', {});
($ok, $sys) = $cce->get($sys_oid);
($ok) = $cce->set($sys_oid, '',{        # beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
    'gui_list_ip' => $vpsid
});

$MN_BackupRemoteTargetHost = $sys->{'MN_BackupRemoteTargetHost'};
$MN_BackupRemoteLocation = $sys->{'MN_BackupRemoteLocation'};

if ($DEBUG == 1) {
    system("echo \"VPSID-debug: controlAction: $vserver_new->{controlAction}\" >> /tmp/vpsctl");
}

if (($vpsid) && ($vserver_new->{controlAction})) {
    if ($DEBUG == 1) {
	system("echo \"VPSID-debug: $vserver_new->{controlAction}\" >> /tmp/vpsctl");
    }
    if (($vserver_new->{controlAction} eq "start") && ($vpsstatus eq "stopped")) {
	if ($DEBUG == 1) {
	    system("echo \"VPSID-cmd: /usr/sbin/vzctl start $vpsid\" >> /tmp/vpsctl");
	}
	system("/usr/sbin/vzctl start $vpsid");
    }
    elsif (($vserver_new->{controlAction} eq "stop") && ($vpsstatus eq "running")) {
	if ($DEBUG == 1) {
	    system("echo \"VPSID-cmd: /usr/sbin/vzctl stop $vpsid\" >> /tmp/vpsctl");
	}
	system("/usr/sbin/vzctl stop $vpsid");
    }
    #elsif (($vserver_new->{controlAction} eq "reboot") && ($vpsstatus eq "running")) {
    elsif ($vserver_new->{controlAction} eq "reboot") {
	if ($DEBUG == 1) {
	    system("echo \"VPSID-cmd: /usr/sbin/vzctl reboot $vpsid\" >> /tmp/vpsctl");
	}
	system("/usr/sbin/vzctl restart $vpsid");
    }
    # Delete a VPS:
    elsif ($vserver_new->{controlAction} eq "deleteconfirm") {
	if ($DEBUG == 1) {
	    system("echo \"VPSID-cmd: Delete confirmation received: $vserver_new->{controlAction}\" >> /tmp/vpsctl");
	}

	# Find all the IP address allocation entries to destroy
	@ipaddresses = $cce->findx('vpsIPalloc', { 'vpsid' => $vpsid });
	#$total = scalar(@ipaddresses);
	if ($DEBUG == 1) {
	    system("echo \"VPSID-cmd alloc: Todal destroylist for VPS $vpsid: $total\" >> /tmp/vpsctl");
	}
	for $ip (@ipaddresses) {
    	    ($ok) = $cce->destroy($ip);
	    if ($DEBUG == 1) {
		system("echo \"VPSID-cmd: Destroying IP alloc OID $ip for VPS $vpsid\" >> /tmp/vpsctl");
	    }
	}
	# Find all backup related entries for the VPS we delete and remove them as well:
	@backup_stuff = $cce->findx('Vserver_Backup', { 'vpsid' => $vpsid });
        for $backup_data (@backup_stuff) {
            ($ok) = $cce->destroy($backup_data);
            if ($DEBUG == 1) {
                system("echo \"VPSID-cmd: Destroying Vserver_Backup OID $backup_data for VPS $vpsid\" >> /tmp/vpsctl");
            }
        }
	# Find the VPS entry to destroy:
	@addresses = $cce->find('Vserver', { 'vpsid' => $vpsid });
	$total = scalar(@addresses);
	if ($DEBUG == 1) {
	    system("echo \"VPSID-cmd Vserver: Todal destroylist for VPS $vpsid: $total\" >> /tmp/vpsctl");
	}
	for $entry (@addresses) {
    	    ($ok) = $cce->destroy($entry);
	    if ($DEBUG == 1) {
		system("echo \"VPSID-cmd: Destroying OID $entry belonging to VPS $vpsid\" >> /tmp/vpsctl");
	    }
	}

	# Remove Traffic related info:
	if (-f "/var/lib/averrd/vps_$vpsid.rrd") {
		system("/bin/rm -f /var/lib/averrd/vps_$vpsid.rrd");
		system("/bin/rm -f /usr/sausalito/ui/web/vz/traffic/images/vps_$vpsid-*.png");
	}
	if (-d "/usr/sausalito/ui/web/vz/traffic/vpsimages/$vpsid") {
		system("/bin/rm -Rf /usr/sausalito/ui/web/vz/traffic/vpsimages/$vpsid");
	}

	# Do the dirty deeds: Stop VPS and destroy VPS:
	system("/usr/sbin/vzctl stop $vpsid --fast");
	system("sleep 5");
	system("/usr/sbin/vzctl destroy $vpsid");
    }
    # Change canned config file of VPS:
    elsif ($vserver_new->{controlAction} eq "resetchangeconfig") {
	($sys_oid) = $cce->find('Vserver', {'vpsid' => $vpsid});
	($ok, $sysvs) = $cce->get($sys_oid);
	($ok) = $cce->set($sys_oid, '',{        # beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
	    'vpsid' => $vpsid,
	    'conf_action' => time()
	});
    }
    # Restore a VPS:
    # Handle case "Local Restore":
    elsif ($vserver_new->{controlAction} eq "localrestoreconfirm") {
	if ($DEBUG == 1) {
	    system("echo \"VPSID-cmd: Confirmation received for Local restore of VPS $vpsid: $vserver_new->{controlAction}\" >> /tmp/vpsctl");
	}
	# Do the dirty deeds - if we have what we need, like a backup VPS and a backup conf:
	if ((-d "/vz/backup/vps/$vpsid" ) || (-e "/vz/backup/conf/$vpsid.conf" )) {
	    # Do the dirty deeds: Stop the VPS :
	    system("/usr/sbin/vzctl stop $vpsid --fast");
	    system("sleep 5");
	    # Copy the data from the backup location to the production environment:
	    system("/usr/bin/rsync -q --progress -var /vz/backup/vps/$vpsid /vz/private/ --delete-after");
	    system("/bin/cp /vz/backup/conf/$vpsid.conf /etc/vz/conf/$vpsid.conf");
	    # Start the VPS again:
	    system("/usr/sbin/vzctl start $vpsid");
	    #system("/usr/sausalito/constructor/vz/vserver/generate_vserver_list.pl");
	}
	else {
		print STDERR "Error while restoring backup:\n";
		print STDERR "Unable to find /vz/backup/vps/$vpsid and/or /vz/backup/conf/$vpsid.conf !\n";
	}
    }
    # Handle case "Remote Restore":
    elsif ($vserver_new->{controlAction} eq "remoterestoreconfirm") {
	if ($DEBUG == 1) {
	    system("echo \"VPSID-cmd: Confirmation received for Remote restore of VPS $vpsid: $vserver_new->{controlAction}\" >> /tmp/vpsctl");
	}
	# Do the dirty deeds - if we have what we need, like a backup VPS and a backup conf:
	if (($MN_BackupRemoteTargetHost ne "") || ($MN_BackupRemoteLocation ne "")) {
	    # Do the dirty deeds: Stop the VPS :
	    system("/usr/sbin/vzctl stop $vpsid --fast");
	    system("sleep 5");
	    # Copy the data from the backup location to the production environment:
	    system("/usr/bin/rsync -q --progress -var -e ssh $MN_BackupRemoteTargetHost:$MN_BackupRemoteLocation/vps/$vpsid /vz/private/ --delete-after");
	    system("/usr/bin/rsync -q --progress -var -e ssh $MN_BackupRemoteTargetHost:$MN_BackupRemoteLocation/conf/$vpsid.conf /etc/vz/conf/ --delete-after");
	    # Start the VPS again:
	    system("/usr/sbin/vzctl start $vpsid");
	    #system("/usr/sausalito/constructor/vz/vserver/generate_vserver_list.pl");
	}
	else {
		print STDERR "Error while restoring backup:\n";
		print STDERR "No remote host and remote directory specified!\n";
	}
    }
    &cleanup;
}

sub cleanup {
    # Control action also needs to be reset to 'none' once we're done - but not on delete!
    if (($vserver_new->{controlAction} ne "deleteconfirm") && ($vpsid)) {
	($sys_oid) = $cce->find('Vserver', {'vpsid' => $vpsid});
	($ok, $sysvs) = $cce->get($sys_oid);
	($ok) = $cce->set($sys_oid, '',{        # beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
	    'vpsid' => $vpsid,
	    'controlAction' => 'none'
	});
    }
}

# We need to say 'SUCCESS' or CCE will bitch:
$cce->bye('SUCCESS');
exit(0);


