#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: ip_make_sense.pl,v 1.0.0.5 Fri 28 Mar 2008 02:03:44 PM CET mstauber Exp $
# Copyright 2006-2008 Solarspeed Ltd. All rights reserved.
#
# Run checks on the values passed through the GUI to make sure that they make sense.
# This one is for the IP address allocation of VPS's.

use CCE;
use POSIX qw(isalpha);

my $DEBUG = 0;

my $cce = new CCE('Domain' => 'vz-vserver');

$cce->connectfd();
#$cce->connectuds(); # only for debugging

my $vserver = $cce->event_object();
my $vserver_new = $cce->event_new();
my $vserver_old = $cce->event_old();

my @oids= $cce->find("Vserver");
my ($ok, $system) = $cce->get($oids[0]);

# Check if VPS IP-Address causes conflict:
if (($vserver_new->{min}) || ($vserver->{min}) || ($vserver_old->{min})) {

	if ($vserver->{min} ne '') { $validate_ip = $vserver->{min}; }
	if ($vserver_old->{min} ne '') { $validate_ip = $vserver_old->{min}; }
	if ($vserver_new->{min} ne '') { $validate_ip = $vserver_new->{min}; }

        my @oids = $cce->findx("Vserver", {},
                               {
                                'ip' => $validate_ip
                               });

        # there should be no oids found
        if (scalar(@oids) > 0) {
		print "FAIL! \n";
                $cce->bye('FAIL', "[[vz-vserver.ipInUse,ip='$validate_ip']]");
                exit(1);
        }

	# verify that the VPS doesn't have the same IP as the master node itself:
	my ($network) = $cce->find('Network', { 'ipaddr' => $validate_ip, 'enabled' => '1' });
        if ($network) {
                $cce->bye('FAIL', "[[vz-vserver.ipInUseMasterNode,ip='$validate_ip']]");
                exit(1);
	}

	# Now check if this IP has already been assigned as extra IP for another VPS:
        my @oids = $cce->findx('vpsIPalloc', { 'min' => $validate_ip });
        # there should be no oids found
        if (scalar(@oids) > 1) {
		print "FAIL! \n";
                $cce->bye('FAIL', "[[vz-vserver.ipInUseExtra,ip='$validate_ip']]");
                exit(1);
        }
}


$cce->bye('SUCCESS');
exit(0);

