#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: make_sense_create.pl,v 1.0.0.6 Mon 14 Apr 2008 06:30:50 PM CEST mstauber Exp $
# Copyright 2006-2008 Solarspeed Ltd. All rights reserved.
#
# Run checks on the values passed through the GUI to make sure that they make sense.
# This handler is run when a new VPS is created to check if IPs are already in use.
#

use CCE;
use POSIX qw(isalpha);

$DEBUG = 0;

$cce = new CCE('Domain' => 'vz-vserver');
#$cce = new CCE;

$cce->connectfd();

$vserver = $cce->event_object();
$vserver_new = $cce->event_new();
$vserver_old = $cce->event_old();

@oids= $cce->find("Vserver");
($ok, $system) = $cce->get($oids[0]);

# Check if VPS IP-Address causes conflict:
if (($vserver_new->{ip}) || ($vserver->{ip}) || ($vserver_old->{ip})) {

    if ($vserver->{ip} ne '') { $validate_ip = $vserver->{ip}; }
    if ($vserver_old->{ip} ne '') { $validate_ip = $vserver_old->{ip}; }
    if ($vserver_new->{ip} ne '') { $validate_ip = $vserver_new->{ip}; }

        @oids = $cce->findx("Vserver", {},
                               {
                                'ip' => $validate_ip
                               });

        # there should be no oids found
        if (scalar(@oids) > 1) {
                $the_scalar = scalar(@oids);
                $out_msg = $oids[0];
                $cce->bye('FAIL',
                          "[[vz-vserver.ipInUse,ip='$validate_ip (CCE Object ID: $out_msg - $the_scalar)']]");
                exit(1);
        }

        # verify that the VPS doesn't have the same IP as the master node itself:
        my ($network) = $cce->find('Network', { 'ipaddr' => $validate_ip, 'enabled' => '1' });
        if ($network) {
                $cce->bye('FAIL',
                          "[[vz-vserver.ipInUseMasterNode,ip='$validate_ip (CCE Object ID: $network)']]");
                exit(1);
        }

        # Also check vpsIPalloc for IPs that may be assigned as 2ndary IPs to other VPSs:
        @oids = $cce->findx("vpsIPalloc",
                               {
                                'min' => $validate_ip
                               });

        # there should be no oids found
        if (scalar(@oids) > 0) {
                $the_scalar = scalar(@oids);
                foreach $line (@oids) {
                        $out_msg = $out_msg . " " . $line;
                }

                $cce->bye('FAIL',
                          "[[vz-vserver.ipInUse,ip='$validate_ip (CCE Object ID:$out_msg - $the_scalar)']]");
                exit(1);
        }
}

$cce->bye('SUCCESS');
exit(0);

