#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: vz_backup_vps_parse.pl, v 1.0.0.0 Tue 11 Mar 2008 06:05:52 AM CET mstauber Exp $
# Copyright 2006-2008 Solarspeed Ltd. All rights reserved.
#
# Handler which polls all Vserver_Backup objects and removes or writes the config file 
# /etc/vz/aconf/vps-vps-backup.conf which contains flat file info about which VPS is to 
# be backed up when and where to.
#

$whatami = "handler";

use CCE;
use POSIX qw(isalpha);
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

if ($whatami eq "handler") {
    $cce->connectfd();
}
else {
    $cce->connectuds();
}

$oid = $cce->event_oid();
$obj = $cce->event_object();

$vserver_cronVPSConfig = "/etc/vz/aconf/vps-vps-backup.conf";

if (!-d "/etc/vz/aconf") {
    system("/bin/mkdir /etc/vz/aconf");
}

@oids = $cce->find('Vserver_Backup');

if (defined($oids[0])) {

    open(CRON, ">$vserver_cronVPSConfig") || die "Can't write to $vserver_cronVPSConfig";
    print CRON "# vzbackup - Aventurin{e} Backup \n";
    print CRON "# DO NOT EDIT! THIS FILE IS GENERATED AUTOMATICALLY THROUGH THE GUI!\n";
    print CRON "\n";

    $a = 0;
    foreach $line (@oids) {
            ($ok, $system) = $cce->get($line);
	    $CONFIG[$a][0] = $system->{'vpsid'};
	    $CONFIG[$a][1] = $system->{'ip'};
	    $CONFIG[$a][2] = $system->{'hostname'};
	    $CONFIG[$a][3] = $system->{'LBpresent'};
	    $CONFIG[$a][4] = $system->{'LRpresent'};
	    $CONFIG[$a][5] = $system->{'LRtimestamp'};
	    $CONFIG[$a][6] = $system->{'LBtimestamp'};
	    $CONFIG[$a][7] = $system->{'VserverBackupLocalEnabled'};
	    $CONFIG[$a][8] = $system->{'VserverBackupRemoteEnabled'};
	    $CONFIG[$a][9] = $system->{'VserverBackupEnabled'};
	    $CONFIG[$a][10] = $system->{'VserverBackupRemoteAuthority'};
	    print CRON "$CONFIG[$a][0]&$CONFIG[$a][1]&$CONFIG[$a][2]&$CONFIG[$a][3]&$CONFIG[$a][4]&$CONFIG[$a][5]&$CONFIG[$a][6]&$CONFIG[$a][7]&$CONFIG[$a][8]&$CONFIG[$a][9]&$CONFIG[$a][10]\n";
	    $a++;
    }
    print CRON "\n";
    print CRON "\n";
    close CRON;    
    system("/bin/chmod 600 $vserver_cronVPSConfig");
}
else {
    system("/bin/rm -f $vserver_cronVPSConfig");
}

$cce->bye('SUCCESS');
exit(0);

