#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: vzbackup.pl, v 1.0.0.0 Sun 18 Feb 2007 12:17:28 PM EST mstauber Exp $
# Copyright 2006-2007 Solarspeed Ltd. and NuOnce Networks, Inc. All rights reserved.
#
# Handler which reads VserverMasterNode and removes or writes /etc/cron.d/vps-backup.cron
# to enable or disable the local and remote backup of VPS's.
#

use CCE;
use POSIX qw(isalpha);

my $cce = new CCE;
$cce->connectfd();
#$cce->connectuds();

$oid = $cce->event_oid();
$obj = $cce->event_object();

@oids = $cce->find('VserverMasterNode');
if (!defined($oids[0])) {
	print STDERR "VZBACKUP: Sorry, no VserverMasterNode object in CCE found!\n";
	exit 1;
}

$vserver_cronCrontab = "/etc/cron.d/vps-backup.cron";
$vserver_cronConfig = "/etc/vz/aconf/vps-mn-backup.conf";

if (!-d "/etc/vz/aconf") {
    system("/bin/mkdir /etc/vz/aconf");
}

($ok, $solbackupValues) = $cce->get($oids[0]);

if ($ok) {

    solbackupSetCrontab(
        $solbackupValues->{'MN_LocalBackupEnabled'},
        $solbackupValues->{'MN_RemoteBackupEnabled'},
        $solbackupValues->{'backupSU'},
        $solbackupValues->{'backupMO'},
        $solbackupValues->{'backupTU'},
        $solbackupValues->{'backupWE'},
        $solbackupValues->{'backupTH'},
        $solbackupValues->{'backupFR'},
        $solbackupValues->{'backupSA'},
        $solbackupValues->{'backupTime'},

	$solbackupValues->{'MN_BackupRemoteTargetHost'},
	$solbackupValues->{'MN_BackupRemoteTargetUser'},
	$solbackupValues->{'MN_BackupRemoteTargetPort'},
	$solbackupValues->{'MN_BackupRemoteLocation'},
	$solbackupValues->{'MN_BackupLocalLocation'}
	
        );
}

$cce->bye('SUCCESS');
exit(0);

##
## Sort the stuff for the crontab file
##

sub solbackupSetCrontab {

    my $MN_LocalBackupEnabled 	= shift;
    my $MN_RemoteBackupEnabled 	= shift;
    my $backupSU   		= shift;
    my $backupMO   		= shift;
    my $backupTU   		= shift;
    my $backupWE   		= shift;
    my $backupTH   		= shift;
    my $backupFR   		= shift;
    my $backupSA   		= shift;
    my $backupTime   		= shift;

    if (($MN_LocalBackupEnabled == "1") || ($MN_RemoteBackupEnabled == "1")) {
	$backup_enabled = "1";
    }
    else {
	$backup_enabled = "0";
    }

    ($h, $m) = split(':', $backupTime);
    my $crontab_entry = "$m $h * * ";
    my $hv = ($h+1);
    if ($hv >=24) { $hv = 0; } 
    my $vserver_cron_time = "$m $hv * *";
    my $hu = ($hv+'1');

    my $tmp_crontab_entry =
        ($backupSU eq 1 ? "0," : "")
      . ($backupMO eq 1 ? "1," : "")
      . ($backupTU eq 1 ? "2," : "")
      . ($backupWE eq 1 ? "3," : "")
      . ($backupTH eq 1 ? "4," : "")
      . ($backupFR eq 1 ? "5," : "")
      . ($backupSA eq 1 ? "6," : "");

    $tmp_crontab_entry =~ s/,$//;
    $tmp_crontab_entry = "*" if length($tmp_crontab_entry) < 1;
    $crontab_entry .= $tmp_crontab_entry . " root /usr/sausalito/sbin/vz_vserver_backup.pl\n";
    chomp($crontab_entry);

    if ($backup_enabled == 1) {
	open(CRON, ">$vserver_cronCrontab") || die "Can't write to crontab";
	print CRON "# vzbackup - Aventurin{e} Backup \n";
        print CRON "# DO NOT EDIT! THIS FILE IS GENERATED AUTOMATICALLY THROUGH THE GUI!\n";
        print CRON $crontab_entry;
        print CRON "\n";
        print CRON "\n";
        close CRON;
	system("/bin/chmod 644 $vserver_cronCrontab");
    }
    else {
	# Delete server cron:
	if ( -e $vserver_cronCrontab ) {
	    unlink($vserver_cronCrontab);
	}
    }
    
    # CROND restart::
    system("/etc/init.d/crond stop > /dev/null 2>&1");
    system("/etc/init.d/crond start > /dev/null 2>&1");

    # Write cronConfig:

    my $MN_BackupRemoteTargetHost   		= shift;
    my $MN_BackupRemoteTargetUser   		= shift;
    my $MN_BackupRemoteTargetPort   		= shift;
    my $MN_BackupRemoteLocation   		= shift;
    my $MN_BackupLocalLocation   		= shift;

    open(CRONC, ">$vserver_cronConfig") || die "Can't write to $vserver_cronConfig";
    print CRONC "# vzbackup - Aventurin{e} Backup \n";
    print CRONC "# DO NOT EDIT! THIS FILE IS GENERATED AUTOMATICALLY THROUGH THE GUI!\n";
    print CRONC "\n";
    print CRONC "MN_LocalBackupEnabled $MN_LocalBackupEnabled\n";
    print CRONC "MN_RemoteBackupEnabled $MN_RemoteBackupEnabled\n";
    print CRONC "backupSU $backupSU\n";
    print CRONC "backupMO $backupMO\n";
    print CRONC "backupTU $backupTU\n";
    print CRONC "backupWE $backupWE\n";
    print CRONC "backupTH $backupTH\n";
    print CRONC "backupFR $backupFR\n";
    print CRONC "backupSA $backupSA\n";
    print CRONC "backupTime $backupTime\n";

    print CRONC "MN_BackupRemoteTargetHost $MN_BackupRemoteTargetHost\n";
    print CRONC "MN_BackupRemoteTargetUser $MN_BackupRemoteTargetUser\n";
    print CRONC "MN_BackupRemoteTargetPort $MN_BackupRemoteTargetPort\n";
    print CRONC "MN_BackupRemoteLocation $MN_BackupRemoteLocation\n";
    print CRONC "MN_BackupLocalLocation $MN_BackupLocalLocation\n";

    print CRONC "\n";
    close CRONC;
    system("/bin/chmod 600 $vserver_cronConfig");

}

exit 0;

