#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: vserver_destroy.pl,v 1.0.0.0 Sun 19 Nov 2006 02:19:43 PM EST mstauber Exp $
# Copyright 2006 Solarspeed Ltd. and NuOnce Networks, Inc. All rights reserved.
#
# Handler which destroys VPS's and removes all CCE objects related to that VPSID
#
# Usage:  vserver_destroy.pl <site name> <page to redirect to when finished>
#

use strict;
use CCE;
use FileHandle;
use File::Path;

# sane umask
umask(002);

my $cce = new CCE;
$cce->connectuds();

$cce->authkey($ENV{'CCE_USERNAME'}, $ENV{'CCE_SESSIONID'});

# make sure the passed site name is valid
my ($site_oid) = $cce->find('Vserver', { 'vpsid' => $ARGV[0] });
if (!$site_oid) {
        exit(1);
}

# find all the IP address allocation entriesto destroy
my @ipaddresses = $cce->find('vpsIPalloc', { 'vpsid' => $ARGV[0] });

my $processed = 0;
my $total = scalar(@ipaddresses) + 1;

for my $ip (@ipaddresses) {
        my ($ok, @info) = $cce->destroy($ip);
        if (!$ok) {
                # failed. update status and exit.
        } else {
                $processed++;
        }
}

# now destroy the site
system("/usr/sbin/vzctl stop $ARGV[0] --fast");
system("sleep 2");	       
system("/usr/sbin/vzctl destroy $ARGV[0]");	       

my ($ok, @info) = $cce->destroy($site_oid);
my $exit = 0;
if ($ok) {
    # Done
        $exit = 0;
} else {
    # Failed
        $exit = 1;
}

$cce->bye();
exit($exit);

